#include "use_cases.hpp"
#include "tuning.hpp"
#include <iostream>

#define STR(S) #S
#define XSTR(S) STR(S)

int main(){

#define RUN_TYPE_FUNC(STRUCT,T,F)\
	std::cout << XSTR(F) << "(" << XSTR(STRUCT) << "<" << XSTR(T) << ">)" << std::endl;\
	F<STRUCT<T>,T>(XSTR(F), XSTR(STRUCT), XSTR(T));\
	std::cout << "done" << std::endl;

#ifdef FUNC
	#define RUN_TYPE(STRUCT,T) RUN_TYPE_FUNC(STRUCT,T,FUNC);
#else
	#define RUN_TYPE(STRUCT, T)\
		RUN_TYPE_FUNC(STRUCT,T,search_random);\
		RUN_TYPE_FUNC(STRUCT,T,search_ascending);\
		RUN_TYPE_FUNC(STRUCT,T,growth_insert_random);\
		RUN_TYPE_FUNC(STRUCT,T,growth_insert_ascending);\
		RUN_TYPE_FUNC(STRUCT,T,growth_insert_descending);\
		RUN_TYPE_FUNC(STRUCT,T,growth_insert_middle);\
		RUN_TYPE_FUNC(STRUCT,T,shrink_erase_random);\
		RUN_TYPE_FUNC(STRUCT,T,forward_iteration);\
		RUN_TYPE_FUNC(STRUCT,T,indel_random);
#endif

#ifdef TYPE
	#define RUN(STRUCT) RUN_TYPE(STRUCT,TYPE)
#else
	#define RUN(STRUCT)\
		RUN_TYPE(STRUCT,int);\
		RUN_TYPE(STRUCT,string);\
		RUN_TYPE(STRUCT,record<50>);
#endif


#ifdef STRUCTURE
	RUN(STRUCTURE);
#else
	RUN(adaptive_slack_set);
	RUN(b_plus_set);
	RUN(circular_set);
	RUN(comparable_hash_set);
	RUN(comparable_hash_set2);
	RUN(custom_flat_set)
	RUN(flat_set);
	RUN(merge_set);
	RUN(proxy_slack_set);
	RUN(set);
	RUN(slack_set);
	RUN(slide_set);
#endif
}
